
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C#引用类型（class)和值类型(struct) / 憋错料</title>

    <meta name="description" content="C#引用类型（class)和值类型(struct) 1. 值参数 当利用值向方法传递参数时,编译程序给实参的值做一份拷贝,并且将此拷贝传递给该方法.被调用的方法不传内存中实参的值,所以使用值参数时,可以保证实际值是安全的. using System; class Test { static void Swap(int x,int y){ int temp=x; x=y; y=temp; } static void Main(){ int i=1,j=2; Swap(i,j); Console.WriteLine(&quot;i={0},j={1} ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">C#引用类型（class)和值类型(struct)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h3>1.&nbsp;<strong>值参数</strong></h3>
<p>　　<strong>当利用值向方法传递参数时，编译程序给实参的值做一份拷贝，并且将此拷贝传递给该方法</strong>。被调用的方法不传内存中实参的值，所以使用值参数时，可以保证实际值是安全的。</p>
<p>　　</p>
<pre>using System;
class Test
{
static void Swap(int x,int y){
int temp=x;
x=y;
y=temp;
}
static void Main(){
int i=1,j=2;
Swap(i,j);
Console.WriteLine("i={0},j={1}",i,j);
}
}</pre>
<p>　　i=1,j=2</p>
<h3>2.&nbsp;<strong>引用型参数</strong></h3>
<p><strong>　　和值参不同的是，引用型参数并不开辟新的内存区域。当利用引用型参数向方法传递形参时，编译程序将把实际值在内存中的地址传递给方法。</strong></p>
<p><strong>　　</strong></p>
<pre>using System;
class Test
{
static void Swap(ref int x,ref int y){
int temp=x;
x=y;
y=temp;
}
static void Main(){
int i=1,j=2;
Swap(ref i,ref j);
Console.WriteLine("i={0},j={1}",i,j);
}
}</pre>
<p>　　i=2,j=1</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 09:55:57 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/class/" title="class">class</a>, <a href="https://www.biecuoliao.com/tag/div/" title="div">div</a>, <a href="https://www.biecuoliao.com/tag/%e5%bc%95%e7%94%a8/" title="引用">引用</a>, <a href="https://www.biecuoliao.com/tag/write/" title="write">write</a>, <a href="https://www.biecuoliao.com/tag/%e4%b8%8d%e5%90%8c%e7%9a%84/" title="不同的">不同的</a>, <a href="https://www.biecuoliao.com/tag/%e6%8b%b7%e8%b4%9d/" title="拷贝">拷贝</a>, <a href="https://www.biecuoliao.com/tag/swap/" title="swap">swap</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>C#引用类型（class)和值类型(struct)的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rbb6a3.html" rel="bookmark">值类型struct在foreach中的陷阱</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近踩了一个坑,为了优化代码,把class改为了struct,结果发现原来的初始化语句没有预期的运行,伪代码如下: public struct A { bool _isActive; public void Init(bool isActive) { _isActive = isActive; } } public A[] _arrayA; //调用如下 foreach A a in _arrayA) { a.Init(); } 看着是能达到预期的,但实际上不是的.            在fo			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVgvWz0.html" rel="bookmark">【转】c&num;引用类型与值类型的区别大盘点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				解析:CLR支持两种类型:值类型和引用类型.用Jeffrey Richter(&lt;CLR via C#&gt;作者)的话来说,“不理解引用类型和值类型区别的程序员将会把代码引入诡异的陷阱和诸多性能问题”.这就要求我们正确理解和使用值类型和引用类型. 值类型包括C#的基本类型(用关键字int.char.float等来声明),结构(用struct关键字声明的类型),枚举(用enum关键字声明的类型):而引用类型包括类(用class关键字声明的类型)和委托(用delegate关键字声明的特殊类).C#中的每			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dx5jZ0.html" rel="bookmark">【转】C&num;详解值类型和引用类型区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				通用类型系统 值类型 引用类型 值类型和引用类型在内存中的部署 1 数组 2 类型嵌套 辨明值类型和引用类型的使用场合 5 值类型和引用类型的区别小结 首先,什么是值类型,什么是引用类型? 在C#中值类型的变量直接存储数据,而引用类型的变量持有的是数据的引用,数据存储在数据堆中. 值类型(value type):byte,short,int,long,float,double,decimal,char,bool 和 struct 统称为值类型.值类型变量声明后,不管是否已经赋值,编译器为其分配内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eqkew0.html" rel="bookmark">C&num; 类型基础 值类型和引用类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 本文之初的目的是讲述设计模式中的 Prototype(原型)模式,但是如果想较清楚地弄明白这个模式,需要了解对象克隆(Object Clone),Clone其实也就是对象复制.复制又分为了浅度复制(Shallow Copy)和深度复制(Deep Copy),浅度复制和深度复制又是以如何复制引用类型成员来划分的.由此又引出了引用类型和值类型,以及相关的对象判等.装箱.拆箱等基础知识.索性从最基础的类型开始自底向上写起. 值类型和引用类型 先简单回顾一下C#中的类型系统.C# 中的类型一共分为			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OanKGM.html" rel="bookmark">006&period;值类型、引用类型、枚举类型、字符串、冒泡排序</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.二维数组和交错数组 2.参数数组:params 数据类型[]数组名只能有一个参数数组,必须是最后一个参数必须是一堆数组 同时存在其他的重载方法,方法调用时优先调用参数最匹配的,没有直接匹配的参数列表时,才调用带有参数列表的方法 3.类型:值类型:整型 float double decimal bool char 枚举 结构引用类型:string 数组(Array)类 接口 委托 4.枚举访问修饰符 enum 枚举{值1,值2}枚举定义的位置:命名空间和类都可以转换:(枚举类型)Enum.Pa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0x89P70.html" rel="bookmark">20151024&lowbar;001&lowbar;C&num;基础知识&lpar;静态与非静态的区别&comma;值类型和引用类型&comma;堆和栈的区别&comma;字符串的不可变性&comma;命名空间&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1:我们把这些具有相同属性和相同方法的对象进行进一步的封装,抽象出来类这个概念. 类就是个模子,确定了对象应该具有的属性和方法. 对象是根据类创建出来的. 2:类:语法 [public] class 类名 { 字段; 属性; 方法; } 写好了一个类之后,我们需要创建这个类的对象,那么,我们管创建这个类的对象过程称之为类的实例化.使用关键字new 实例化类===创建类 this:表示当前这个类的对象. 类是不占内存的,而对象是占用内存的. 结构是面向过程的,类是面向对象的,之前没有面向对象的时候			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgXp980.html" rel="bookmark">引用类型和值类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				CLR支持两种类型:引用类型和值类型. 虽然FCL中大多数都是引用类型,但开发人员用的最多的还是值类型.引用类型总是在托管堆上分配的,C#的new操作符会返回对象的内存地址——也就是指向对象数据的内存地址. 使用引用类型必须注意到一些性能问题,首先考虑一下事实: 1)内存必须从托管堆上分配. 2)对上分配的每个对象都有一些额外的成员(比如前面提到过得&quot;类型对象指针&quot;和&quot;同步块索引&quot;),这些成员必须初始化. 3)对象中的其他字节(为字段而设)总是设为零. 4)从托管堆			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pPyRg4.html" rel="bookmark">c&num; 引用类型与值类型的区别有哪些</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				解析:CLR支持两种类型:值类型和引用类型.用Jeffrey Richter(&lt;CLR via C#&gt;作者)的话来说,“不理解引用类型和值类型区别的程序员将会把代码引入诡异的陷阱和诸多性能问题”.这就要求我们正确理解和使用值类型和引用类型. 值类型包括C#的基本类型(用关键字int.char.float等来声明),结构(用struct关键字声明的类型),枚举(用enum关键字声明的类型):而引用类型包括类(用class关键字声明的类型)和委托(用delegate关键字声明的特殊类).C#中的每			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eErdb0.html" rel="bookmark">&period;Net中值类型和引用类型的区别</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				解析:CLR支持两种类型:值类型和引用类型.用Jeffrey Richter(&lt;CLR via C#&gt;作者)的话来说,&quot;不理解引用类型和值类型区别的程序员将会把代码引入诡异的陷阱和诸多性能问题&quot;.这就要求我们正确理解和使用值类型和引用类型. 值类型包括C#的基本类型(用关键字int.char.float等来声明),结构(用struct关键字声明的类型),枚举(用enum关键字声明的类型):而引用类型包括类(用class关键字声明的类型)和委托(用delegate关键字声明的			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MELOX4.html" rel="bookmark" class="title">Alpha 和Beta 测试</a>
					<div>
						在正式发布产品之前往往要先发布一些测试版,让用户能够反馈出相关信息,或者找到存在的Bug,以便在正式版中得到解决. 特别是在有客户参加的情况下,对系统进行测试可能会出现一些我们没有考虑的情况,还可以解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/AMDa6w0.html" rel="bookmark" class="title">&lbrack;Design Pattern&rsqb; Iterator Pattern 简单案例</a>
					<div>
						Iterator Pattern,即迭代时模式,按照顺序依次遍历集合内的每一个元素,而不用了解集合的底层实现,属于行为类的设计模式.为了方便理解记忆,我也会称其为遍历模式. 下面是一个迭代器模式的简单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xqLQ3.html" rel="bookmark" class="title">组合问题</a>
					<div>
						对ABCD进行组合,使用递归思想. 递归逻辑:使用一个和字符串数组相同长度的布尔数组来确定是否选择某一位字符.每次递归有两次递归调用,一个是当前位为true,也就是选择当前这一位的字符,另一个当前位为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35VDl14.html" rel="bookmark" class="title">错误为Lc&period;exe已退出，代码为-1</a>
					<div>
						近来在做项目的时候,突然遇到 了 LC.exe 已退出,代码为-1 的提示,怎么也编译不了,在查了相关的资料后,终于明白了原因,其解决方案如下 : 1. 以管理员的身份来运行vs, 并把项目中“pro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41gArG0.html" rel="bookmark" class="title">AD服务器不愿意处理该请求</a>
					<div>
						描述 这个提示挺有意思,还不愿意请求-. 这个提示应该会有很多地方会提示,我遇到的是在操作组的MemberOf属性的时候,我需要将一个用户从这个属性中删除掉.使用的代码是: DirectoryEntr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4perYPM.html" rel="bookmark" class="title">批量添加ip出错误之二</a>
					<div>
						Determining if ip address 43.241.255.196 is already in use for device eth1... Determining if ip addr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/My5EWYM.html" rel="bookmark" class="title">数据的基本概念</a>
					<div>
						数据集:数据对象的集合 属性(attribute)是对象的性质或特性,它因对象而异,或随时间而变化. 测量标度(measurement scale)是将数值或符号值与对象的属性相关联的规则(函数) 属 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qQop53.html" rel="bookmark" class="title">JUnit4安装使用报告</a>
					<div>
						新建了一个Java项目,添加了一个calculate.java的class,随后,将JUnit4引入该项目 生成JUnit测试框架:在Eclipse的Package Explorer中用右键点击该类弹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0en2L53.html" rel="bookmark" class="title">ASP&period;Net MVC开发基础学习笔记：三、Razor视图引擎、控制器与路由机制学习</a>
					<div>
						一.天降神器“剃须刀” — Razor视图引擎 1.1 千呼万唤始出来的MVC3.0 在MVC3.0版本的时候,微软终于引入了第二种模板引擎:Razor.在这之前,我们一直在使用WebForm时代沿留 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M61R5y4.html" rel="bookmark" class="title">NOKIA Lumia 920</a>
					<div>
						此页面为WP8&quot;NOKIA Lumia 920&quot;应用的发布页面. &quot;NOKIA Lumia 920&quot;是一款收集Lumia920的玩机技巧的WP8程序,更好的帮助 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyjJaL0.html" rel="bookmark" class="title">LINUX信号发送</a>
					<div>
						测试环境:ubuntu 16.0 编译器:       g++ (Ubuntu 5.4.0-6ubuntu1~16.04.4) 5.4.0 20160609 (查看版本指令:g++ --version ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kDzBl3.html" rel="bookmark" class="title">&lbrack;原&rsqb;openstack-kilo--issue&lpar;二十一&rpar; instance can&amp;&num;39&semi;t get ip 虚拟机不能得到ip（2）</a>
					<div>
						===问题点==== 在使用vlan模式部署compute节点的时候出现了下面的错误:在controller节点的dhcp-agent.log中 2017-01-22 20:19:34.178 241 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDoD9n4.html" rel="bookmark" class="title">数据结构：树状数组</a>
					<div>
						关于树状数组的概述,可以看一下这篇博客:http://blog.csdn.net/int64ago/article/details/7429868 树状数组是一个可以高效地进行区间统计的数据结构,在思 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KBbbLM.html" rel="bookmark" class="title">&lbrack;Python3&rsqb;迭代器和生成器</a>
					<div>
						迭代器 迭代是Python最强大的功能特色,是遍历访问序列元素的一种方式. 迭代器的特性是: 可以记住当前遍历位置 只能往前遍历,不能后退 从序列的第一个元素开始访问,直至所有元素被访问完 有两个基本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQL58M.html" rel="bookmark" class="title">2016年屌丝的风口在哪里</a>
					<div>
						去年支付宝出了生活圈大家说风口来了,支付宝又推出了服务号,大家说风口来了,今日头条火了,大家说风口来了,QQ推出了QQ公众号.大家还说风口来了. 在支付宝刚刚推出这些社交功能的第二天,就有不少人自称: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzAdwq4.html" rel="bookmark" class="title">echo    print    print&lowbar;r的区别</a>
					<div>
						echo       PHP语句   效率最高    输出一个或者多个字符串 print()    函数       效率高     只能打印出简单类型变量的值(如int,string) print_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jeXvAM.html" rel="bookmark" class="title">java-自动登录 与 记住用户名</a>
					<div>
						步骤分析: 步骤分析: 1.数据库和表 create database day16; use day16; create table user( id int primary key auto_inc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Zpg7ZM.html" rel="bookmark" class="title">SUSE Linux--zypper程序包管理（实战命令总结）</a>
					<div>
						(1)zypper ar iso:/?iso=/media/SOFTWARE/openSUSE-11.4-DVD-i586.iso DVDISO 新添加本地iso文件为安装源,名称和别名均为DVDIS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPJJx13.html" rel="bookmark" class="title">iOS阶段学习第六天笔记（数组）</a>
					<div>
						                                                                                              iOS学习( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MooxklM.html" rel="bookmark" class="title">python 3Des 加密</a>
					<div>
						import hashlib; from Crypto.Cipher import DES3 import base64 def create_key(sk): r=hashlib.md5(sk).d ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
